IncludeScript("artifact_system.nut")

/* TO DO LIST 
	-class system 				[ ]
	-option menu				[ ]
	-karma						[/]
	-last player outline		[ ]
	-knife throw 				[ ]

	-fixed players randomly dying on spawn
	-fixed Artifacts carrying over between rounds
	-removed player colision on Artifacts
	-added RDM penalty
	-increased artifact visability
	-added more models to the artifact spawn pool
	-decreased the default map time from 5mins to 3mins
*/

ClearGameEventCallbacks()
::PlayerManager <- Entities.FindByClassname(null, "tf_player_manager");
::GetPlayerUserID <- function(player){
    return NetProps.GetPropIntArray(PlayerManager, "m_iUserID", player.entindex());
}
playerlist 				<- []
droppedgun_check_radius <- 100
murderer 				<- null
roundstate 				<- "preround" // "preround", "midround"

//gamemode roles and role asignment
function giveroles(){
	ClientPrint(null, 3, "\x07FFFF76 THE ROUND HAS STARTED.")
	ClientPrint(null, 3, "\x07E10000 murderers\x07FFFFFF must kill all\x0700D500 bystanders\x07FFFFFF and\x070000F0 sheriffs\x07FFFFFF to win,")
	ClientPrint(null, 3, "\x0700D500 bystanders\x07FFFFFF must survive and find artifacts( sapper gibs) to aquire a gun")
	ClientPrint(null, 3, "\x070000F0 sheriffs\x07FFFFFF must protect the\x0700D500 bystanders\x07FFFFFF by shooting the\x07E10000 murderers")

	roundstate = "midround"
	Convars.SetValue("mp_friendlyfire", 	1)
	Convars.SetValue("mp_autoteambalance", 	0)
	Convars.SetValue("mp_respawnwavetime", 	999)
	Convars.SetValue("tf_dropped_weapon_lifetime", 	0)
	Convars.SetValue("sv_alltalk", 			1)
	Convars.SetValue("tf_gravetalk", 		0)
	printl(Convars.GetInt("mp_friendlyfire"))
	printl(Convars.GetInt("mp_autoteambalance"))
	printl(Convars.GetInt("mp_respawnwavetime"))
	printl(Convars.GetInt("tf_dropped_weapon_lifetime"))
	printl(Convars.GetInt("sv_alltalk"))
	printl(Convars.GetInt("tf_gravetalk"))
	
	//playerlist
	playerlist.clear()
	local playercount = null
	while(playercount = Entities.FindByClassname(playercount, "player")){
		playerlist.append(playercount)
		if (playercount.GetCurrency() != 0) {playercount.SetCurrency(0)}
	}
	/*
	//sheriff
	local sheriff 		= playerlist.remove(RandomInt(0, playerlist.len() - 1))
	sheriff.Regenerate(true)
	local sheriffgun 	= NetProps.GetPropEntityArray(sheriff, "m_hMyWeapons", 0)
	local sheriffknife 	= NetProps.GetPropEntityArray(sheriff, "m_hMyWeapons", 1)
	local sheriffsapper = NetProps.GetPropEntityArray(sheriff, "m_hMyWeapons", 2)
	local sheriffpda 	= NetProps.GetPropEntityArray(sheriff, "m_hMyWeapons", 3)
	local sheriffinvis 	= NetProps.GetPropEntityArray(sheriff, "m_hMyWeapons", 4)
	//sheriff settings
		sheriff.Weapon_SetLast(sheriffsapper)
		if (sheriffpda		!= null) {sheriffpda.Kill()}
		if (sheriffknife 	!= null) {sheriffknife.Kill()}
		if (sheriffinvis 	!= null) {sheriffinvis.Kill()}
		sheriffgun.AddAttribute("damage bonus", 10, -1)
		sheriffgun.AddAttribute("Reload time decreased", 4.5, -1)
		sheriffgun.AddAttribute("fire rate penalty", 1, -1)
		sheriffgun.AddAttribute("maxammo secondary increased", 10, -1)
		sheriffgun.AddAttribute("mod max primary clip override", 1, -1)
		sheriffgun.AddAttribute("cloak consume rate decreased", 1000, -1)
		sheriffgun.AddAttribute("cannot disguise", 1, -1)
		sheriffgun.SetClip1(0)
		sheriff.RemoveDisguise()
		sheriff.Weapon_Switch(sheriffsapper)
		sheriff.ForceChangeTeam(2, true)
		local gametext = SpawnEntityFromTable("game_text",{ 	
		 			message 	= "You are a Sheriff", 
		 			x 			= -1, 
		 			y 			= 0.25,
		 			holdtime 	= 5,
		 			channel 	= 1,
		 			fadein 		= 1,
		 			fadeout 	= 1.5,
		 			color 		= "100 100 100",
		 			color2 		= "240 110 0",
		 			})
		EntFireByHandle(gametext, "Display", "", 0, sheriff, sheriff)
		EntFireByHandle(gametext, "Kill", "", 10, sheriff, sheriff)
		local sheriffcosmetic = null
		while(sheriffcosmetic = Entities.FindByClassname(sheriffcosmetic, "tf_wearable")){
			if (sheriffcosmetic.GetOwner() == self) {sheriffcosmetic.SetTeam(2)}
		}
	*/
	//murderer
	if (playerlist.len() >= 1) {
		murderer 			= playerlist.remove(RandomInt(0, playerlist.len() - 1))
		murderer.Regenerate(true)
		local murdergun 	= NetProps.GetPropEntityArray(murderer, "m_hMyWeapons", 0)
		local murderknife 	= NetProps.GetPropEntityArray(murderer, "m_hMyWeapons", 1)
		local murdersapper 	= NetProps.GetPropEntityArray(murderer, "m_hMyWeapons", 2)
		local murderpda 	= NetProps.GetPropEntityArray(murderer, "m_hMyWeapons", 3)
	 //murderer settings
		murderer.RemoveDisguise()
		if (murderpda != null) {murderpda.Kill()}
		if (murdergun != null) {murdergun.Kill()}
		murderknife.AddAttribute("cannot disguise", 1, -1)
		murderknife.AddAttribute("damage penalty", 4, -1)
		murderer.Weapon_Switch(murdersapper)
		murderer.SetSpyCloakMeter(100)
		local gametext = SpawnEntityFromTable("game_text",{
		 		message 	= "You are a Murderer", 
		 		x 			= -1, 
		 		y 			= 0.25,
		 		holdtime 	= 5,
		 		channel 	= 1,
		 		fadein 		= 1,
		 		fadeout 	= 1.5,
		 		color 		= "100 100 100",
		 		color2 		= "240 110 0",
		 		})
		EntFireByHandle(gametext, "Display", "", 0, murderer, murderer)
		EntFireByHandle(gametext, "Kill", "", 10, murderer, murderer)
		murderer.ValidateScriptScope()
		murderer.GetScriptScope().murderthink <- murderthink
		AddThinkToEnt(murderer, "murderthink")
		local murderercosmetic = null
	
	}
	
	//bystanders
	while(playerlist.len() != 0){
		local bystander 		= playerlist.pop()
		local bystandergun 		= NetProps.GetPropEntityArray(bystander, "m_hMyWeapons", 0)
		local bystanderknife 	= NetProps.GetPropEntityArray(bystander, "m_hMyWeapons", 1)
		local bystandersapper 	= NetProps.GetPropEntityArray(bystander, "m_hMyWeapons", 2)
		local bystanderpda 		= NetProps.GetPropEntityArray(bystander, "m_hMyWeapons", 3)
		local bystanderinvis 	= NetProps.GetPropEntityArray(bystander, "m_hMyWeapons", 4)
		 //bystander settings
			if (bystandergun 	!= null) {bystandergun.Kill()}
			if (bystanderknife 	!= null) {bystanderknife.Kill()}
			if (bystanderinvis	!= null) {bystanderinvis.Kill()}
			bystander.RemoveDisguise()
			bystander.Weapon_Switch(bystandersapper)
			bystander.ForceChangeTeam(2, true)
			local gametext = SpawnEntityFromTable("game_text",{
				 	message 	= "You are a Bystander", 
				 	x 			= -1, 
				 	y 			= 0.25,
				 	holdtime 	= 5,
				 	channel 	= 1,
				 	fadein 		= 1,
				 	fadeout 	= 1.5,
				 	color 		= "100 100 100",
				 	color2 		= "240 110 0",
				 	})
			EntFireByHandle(gametext, "Display", "", 0, bystander, bystander)
			EntFireByHandle(gametext, "Kill", "", 10, bystander, bystander)
			local bystandercosmetic = null
			while(bystandercosmetic = Entities.FindByClassname(bystandercosmetic, "tf_wearable")){
				if (bystandercosmetic.GetOwner() == self){
					bystandercosmetic.SetTeam(2)
				}
			}
	} 
}

function OnGameEvent_player_death(params){
	printl("< < < player has died < < <")
	local stats = Entities.FindByClassname(null, "tf_player_manager")
	local deadplayer 	= GetPlayerFromUserID(params.userid)
	local deadplayergun = NetProps.GetPropEntityArray(deadplayer, "m_hMyWeapons", 0)
	if (NetProps.GetPropBool(self, "m_bForcedSkin") != false) {NetProps.SetPropBool(self, "m_bForcedSkin", false)}
	AddThinkToEnt(deadplayer, null)

	//gun drop on death
	if (deadplayergun != null) {
		SpawnEntityFromTable("prop_physics_override",{
			targetname  = "dropped_gun",
			Model       = "models/weapons/w_models/w_revolver.mdl",
			solid       = 6,
			modelscale 	= 1.2,
			origin      = deadplayer,
			angles      = "0 0 0",
			thinkfunction = "droppedgunthink",
			vscripts    = "matm_RolesController.nut",
			spawnflags = 4,
			}
		)
	}
}

//dropped gun think script
const RETHINK_TIME = 1
function droppedgunthink(){
	local nearbyplayer 		= Entities.FindByClassnameNearest("player", self.GetOrigin(), droppedgun_check_radius)
	local nearbyplayergun 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 0)
	local nearbyplayerknife = NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 1)

	//gives bystanders gun
	if (nearbyplayer != null) {
		if (nearbyplayergun != null || nearbyplayerknife != null) {
		}
		else{
			nearbyplayer.Regenerate(true)
			local nearbyplayergun 		= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 0)
			local nearbyplayerknife 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 1)
			local nearbyplayersapper 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 2)
			local nearbyplayerpda 		= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 3)
			local nearbyplayerinvis 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 4)
			nearbyplayer.Weapon_SetLast(nearbyplayersapper)
			if (nearbyplayerinvis  	!= null) {sheriffinvis.Kill()}
			if (nearbyplayerpda  	!= null) {nearbyplayerpda.Kill()}
			if (nearbyplayerknife 	!= null) {sheriffknife.Kill()}
			nearbyplayergun.AddAttribute("damage bonus", 10, -1)
			nearbyplayergun.AddAttribute("Reload time decreased", 4.5, -1)
			nearbyplayergun.AddAttribute("fire rate penalty", 1, -1)
			nearbyplayergun.AddAttribute("maxammo secondary increased", 10, -1)
			nearbyplayergun.AddAttribute("mod max primary clip override", 1, -1)
			nearbyplayergun.AddAttribute("cloak consume rate decreased", 1000, -1)
			nearbyplayergun.AddAttribute("cannot disguise", 1, -1)
			nearbyplayergun.SetClip1(1)
			nearbyplayer.RemoveDisguise()
			SendToConsole("slot2")
			self.Kill()
		}
	}
    return RETHINK_TIME
}

//force class change
function OnGameEvent_player_spawn(params){
	printl("player has respawned")
	local respawnedplayer = GetPlayerFromUserID(params.userid)
	respawnedplayer.ForceChangeTeam(2, true)
	respawnedplayer.SetPlayerClass(8)
	respawnedplayer.Regenerate(true)
	local respawnedplayergun 	= NetProps.GetPropEntityArray(respawnedplayer, "m_hMyWeapons", 0)
	local respawnedplayerknife 	= NetProps.GetPropEntityArray(respawnedplayer, "m_hMyWeapons", 1)
	local respawnedplayersapper = NetProps.GetPropEntityArray(respawnedplayer, "m_hMyWeapons", 2)
	local respawnedplayerpda 	= NetProps.GetPropEntityArray(respawnedplayer, "m_hMyWeapons", 3)
	local respawnedplayerinvis 	= NetProps.GetPropEntityArray(respawnedplayer, "m_hMyWeapons", 4)
	if (respawnedplayergun		!= null) {respawnedplayergun.Kill()}
	if (respawnedplayerknife	!= null) {respawnedplayerknife.Kill()}
	if (respawnedplayerpda		!= null) {respawnedplayerpda.Kill()}
	if (respawnedplayerinvis	!= null) {respawnedplayerinvis.Kill()}
	respawnedplayer.Weapon_Switch(respawnedplayersapper)
	if (respawnedplayer.GetScriptThinkFunc() == murderthink()) {
		AddThinkToEnt(respawnedplayer, null)
		local spawnedply_cosmetic = null
		while(spawnedply_cosmetic = Entities.FindByClassname(spawnedply_cosmetic, "tf_wearable")){
			spawnedply_cosmetic.SetTeam(2)
		}
	}
}

//murderer think func
const RETHINK_TIME = 0.1
function murderthink() {
	if (self.GetClassname() == "player") {
		if (NetProps.GetPropBool(self, "m_bForcedSkin") != true) {NetProps.SetPropBool(self, "m_bForcedSkin", true)
		}
		if (self.IsFakeClient() == false && self.GetActiveWeapon().GetClassname() == "tf_weapon_builder" || self.IsFakeClient() == false && self.GetActiveWeapon().GetClassname() == "tf_weapon_sapper") {
			NetProps.SetPropInt(self, "m_nForcedSkin", 0)
			//printl("holding sapper")
			local murder_cosmetic = null
			while(murder_cosmetic = Entities.FindByClassname(murder_cosmetic, "tf_wearable")){
				if (murder_cosmetic.GetOwner() == self){
				murder_cosmetic.SetTeam(2)
				}
			}
		}
		else if (self.IsFakeClient() == false && self.GetActiveWeapon().GetClassname() == "tf_weapon_knife" || self.IsFakeClient() == false && self.GetActiveWeapon().GetClassname() == "saxxy") {
			NetProps.SetPropInt(self, "m_nForcedSkin",1)
			//printl("holding knife")
			local fake_cosmetic = null
			while(fake_cosmetic = Entities.FindByClassname(fake_cosmetic, "tf_wearable")){
				if (fake_cosmetic.GetOwner() == self){
					fake_cosmetic.SetTeam(3)
				}
			}
		}

		local buttons = NetProps.GetPropInt(self, "m_nButtons")
		local isPressingReload = buttons & Constants.FButtons.IN_RELOAD
		if (isPressingReload != 0 && self.GetActiveWeapon().GetClassname() == "tf_weapon_knife") {
			//printl("----------Reload Triggered!---------")
			local throwknife = SpawnEntityFromTable("tf_projectile_cleaver", {
    			origin 	= self.EyePosition()+self.EyeAngles().Forward()*50,
    			angles 	= self.EyeAngles()
			})
			throwknife.PrecacheModel("models/weapons/w_models/w_knife.mdl")
			throwknife.ApplyAbsVelocityImpulse(self.EyeAngles().Forward()*1800)
			throwknife.SetOwner(self)
			throwknife.SetTeam(3)
			throwknife.SetModel("models/weapons/w_models/w_knife.mdl") //NEED TO PRECOACH!!!
		}

		if (self.InCond(4) == true) {
			self.AddCustomAttribute("move speed penalty", 1.3, 0.1)
		}

	}
	return RETHINK_TIME
}

//killfeed mod
function OnScriptHook_OnTakeDamage(params) {
	printl(">>>>>>>damage take!<<<<<<<")
	if (NetProps.GetPropEntityArray(params.const_entity, "m_hMyWeapons", 1) == null && NetProps.GetPropEntityArray(params.inflictor, "m_hMyWeapons", 1) == null){
		params.damage = 0
	}
	if (NetProps.GetPropEntityArray(params.const_entity, "m_hMyWeapons", 1) == null && NetProps.GetPropEntityArray(params.inflictor, "m_hMyWeapons", 1) == null)
		{if (params.const_entity.GetClassname() == "player" && NetProps.GetPropEntityArray(params.const_entity, "m_hMyWeapons", 0) == null) {
				params.attacker.TakeDamageEx(
				params.attacker, 
				params.attacker, 
				params.attacker.GetActiveWeapon(), 
				params.attacker.GetOrigin(), 
				params.attacker.GetOrigin(), 
				999, 
				1)
			}
		}
	//printl("inflictor is murderer")
	//params.early_out = true
	params.attacker = params.const_entity
}

//wip code
const RETHINK_TIME = 0
function runscript() {
	local stats = Entities.FindByClassname(null, "tf_player_manager")
	local player = Entities.FindByClassname(null, "player")
	if (NetProps.GetPropIntArray(stats, "m_bAlive", 1) == 0) {
		NetProps.SetPropIntArray(stats, "m_bAlive", 1, 1)
	}
	return RETHINK_TIME
}
__CollectGameEventCallbacks(this)